import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
public class ServeurIdent extends UnicastRemoteObject 
  implements IServeurIdent {
  private Map idMap;
  private Random rng;
  private Map passMap;
  public ServeurIdent() throws RemoteException {
    super();
    idMap = new HashMap();
    passMap = new HashMap();
    rng = new Random();
  }
  // mthode locale
  public void addUser(String user,String pass) {
    // ajout d'un utilisateur
    passMap.put(user,pass);
  }
  public long login(String user,String pass) throws RemoteException {
    if(passMap.containsKey(user)) {
      // l'utilisateur existe
      if(passMap.get(user).equals(pass)) {
	// le mot de passe est le bon
	long id;
	Long idObj;
	do {
	  id = rng.nextLong();
	  idObj = new Long(id);
	} while(idMap.containsKey(idObj));
	// on a engendr un id qui n'est pas dj attribu
	idMap.put(idObj,new UserInfo(user,id));
	// log serveur
	System.out.println("Connexion de "+user+" id : "+id);
	return id;
      }
    }
    throw new RemoteException("Connexion refuse");
  }
  public void logout(long id) throws RemoteException {
    Long idObj = new Long(id);
    if(idMap.containsKey(idObj)) {
      // partie inutile, utilise simplement pour le log serveur
      UserInfo user = (UserInfo)idMap.get(idObj);
      System.out.println("Dconnexion de "+user.user+" id : "+id);
      // suppression de l'id
      idMap.remove(idObj);
    } else {
      throw new RemoteException("Id invalide");
    }
  }
  public void postMessage(long id,String msg) throws RemoteException {
    Long idObj = new Long(id);
    if(idMap.containsKey(idObj)) {
      UserInfo user = (UserInfo)idMap.get(idObj);
      if(user.isValid()) {
	System.out.println(user.user+" : "+msg);
	// on quitte la mthode
	return;
      } else {
	// timeout, on supprime l'id
	logout(id);
      }
    }
    throw new RemoteException("Id invalide");
  }
  public static void main(String[] args) throws Exception {
    // dmarrage du serveur
    ServeurIdent serveur = new ServeurIdent();
    // ajout d'utilisateurs pour les tests
    serveur.addUser("toto","1234");
    serveur.addUser("titi","1234");
    serveur.addUser("bidule","1234");
    Naming.rebind("ServeurIdent",serveur);
    System.out.println("Serveur dmarr");
  }
}
