import java.rmi.*;
import java.rmi.server.*;
public class DoSomethingCallback extends UnicastRemoteObject 
  implements IDoSomethingCallback {
  private String result;
  private boolean done;
  public DoSomethingCallback() throws RemoteException {
    super();
    done = false;
  }
  public synchronized void reportCompletion(String result) throws RemoteException {
    System.out.println("reportCompletion");
    done = true;
    this.result = result;
    notify();
  }
  public synchronized boolean isDone()  {
    return done;
  }
  public synchronized String getResult() {
    return result;
  }
  public synchronized void waitForResult() {
    while(!done) {
      try {
	wait();
      } catch(InterruptedException e) {
      }
    }
  }
}
